package jnicli;
import java.util.*;

class IncrementalCursor implements Cursor { 
    IncrementalCursor(DatabaseJNI db, long cursor, ClassDescriptor desc) { 
        this.db = db;
        this.desc = desc;
        this.cursor = cursor;
        oid = db.jniNext(cursor);
    }

    public int size() { 
        return db.jniGetNumberOfSelectedRecords(cursor);
    }
        
    public boolean hasMoreElements() {
        return oid > 0;
    }

    public Object nextElement() {
        if  (oid == 0) { 
            throw new NoSuchElementException();
        }
        Object obj = db.unswizzleObject(cursor, desc);
        oid = db.jniNext(cursor);
        return obj;
    }

    public long getOid() { 
        return oid;
    }

    public void update() { 
        throw new CliException("Cursor not in update mode");
    }

    protected void finalize() { 
        if (oid != 0) { 
            db.jniCloseCursor(cursor);
        }
    }

    DatabaseJNI     db;
    long            oid;
    long            cursor;
    ClassDescriptor desc;
}
    